 require 'sketchup.rb'


def percer_fraiser_chambrer_05_b_V2014_FREE_FR()
model=Sketchup.active_model
entities = model.active_entities 
selec=model.selection
pt_origine=Geom::Point3d.new
t0 = Geom::Transformation.new pt_origine

if !selec[0]
UI.messagebox "vous devez être en mode édition dans un groupe ou un composant, et avoir sélectionné une face"
end

if selec[0].typename=="Face" and selec[0].parent.typename=="ComponentDefinition"
gp=selec[0].parent
gps=gp.instances
gp_ent=gp.entities
face=selec[0]
normal=face.normal
plan=face.plane
else
UI.messagebox "vous devez être en mode édition dans un groupe ou un composant, et avoir sélectionné une face"
return
end

t1=model.edit_transform
t2=t1.inverse
normal.transform! t2
normal_rev=normal.reverse

status = model.close_active
selec.clear

status=model.start_operation("perçer-fraiser-chambrer")	

reg_ligne=[]
reg_ligne_2=[]
  
entities = model.active_entities 

entities.each {|obj|
	if (obj.typename=="ConstructionLine")
	vec1=obj.direction
	pos=obj.position
	ligne =[ pos,  vec1] 
	reg_ligne.push (ligne)
	reg_ligne_2.push(ligne)
	end 
}

ptts=[]
for a in reg_ligne
	for b in reg_ligne_2
	pttmp=Geom.intersect_line_line(a,b)
		if pttmp!=nil then 
		pttmp2=pttmp.transform t2
			result = face.classify_point(pttmp2)
			#UI.messagebox result
			########troisieme condition
			if result == Sketchup::Face::PointInside
			#UI.messagebox(pttmp2.to_s + ' is inside the face')
			
			ptts.push pttmp.to_a
			end
		end
	end
end

if ptts.length==0
UI.messagebox "aucune lignes de construction sur cette face"
return
end
ptts.uniq!
for i in 0..ptts.length-1
ptts[i]=Geom::Point3d.new (ptts[i])
end


pts=[]
for i in 0..ptts.length-1
pts.push ptts[i].transform t2 #offset vec_base
end

liste1 = %w[percer percer-fraiser percer-chambrer percer-chambrer-fraiser ].join("|")
liste_de_liste=[liste1] 

titre=["Choix","Diametre de perçage ","Profondeur du perçage ","Nombre de segments","Diametre du chambrage","Profondeur du chambrage"]
valeurs=["percer-chambrer-fraiser","10","30",12,"20,1","10"]
resultats = inputbox titre,valeurs,liste_de_liste,"Parametres"
choix=resultats[0]
diametre=resultats[1].to_l
prof=resultats[2].to_l
nb_edges=resultats[3]
diamlam = resultats[4].to_l
proflam = resultats[5].to_l
rayon=diametre/2

#Controles
if ((diametre<("2".to_l) and choix=="percer-chambrer-fraiser") or (diametre<("2".to_l) and choix=="percer-fraiser"))
UI.messagebox ("Fraisage pour un diametre de perçage inferieur a 2mm sera imparfait")
end

if choix=="percer-chambrer-fraiser"
	if diamlam<=(diametre*2)
	message="le diametre du chambrage doit être supérieur a\n"
	message=message+" 2 fois le diametre du perçage"
	UI.messagebox message
	dem=["valeur proposee  "]
	val=[(((2*diametre)+("0,1".to_l)).to_l).to_s]
	cor=inputbox dem,val
	diamlam= cor[0].to_l
	end
end


for i in 0..pts.length-1

normal=face.normal

normal.transform! t1
normal_rev=normal.reverse
laser = [ptts[i], normal_rev]


item = model.raytest laser
#item[1][1].material="red"

pt_averif= item[0]
plan=[ptts[i],normal]#face.plane

verif=item[0].distance_to_plane plan

	if verif<prof
	prof=verif
	end
	
normal.transform! t2
normal_rev.transform! t2
	
  #__PERçAGE__________________________	
begin
cercle1 = gp_ent.add_circle pts[i], normal, rayon, nb_edges
courbe1=cercle1[0].curve
sommets1=courbe1.vertices
loop1=sommets1[0].loops
rond=loop1[0].face
rond.pushpull -prof

normal_rev.length=rayon
t=Geom::Transformation.translation normal_rev
rescue
UI.messagebox ("operation debordante non autorisee")
return
end


 #____CHAMBRAGE____________________
 begin
	if choix=="percer-chambrer"  or choix=="percer-chambrer-fraiser"
	cercle2 = gp_ent.add_circle pts[i], normal, diamlam/2, nb_edges
	courbe2=cercle2[0].curve
	sommets2=courbe2.vertices
	loop2=sommets2[0].loops
	rond2=loop2[0].face
	rond2.pushpull -proflam

	###################ici  v05a  a corriger suivant la face le 31/12/2011
	#pts[i][2]=pts[i][2]-proflam
	normal_rev.length=proflam
	t11=Geom::Transformation.translation normal_rev
	pts[i].transform! t11
	end
rescue
UI.messagebox ("operation debordante non autorisee")
return
end



 #____FRAISAGE____________________
 begin
if choix=="percer-fraiser"      
cercle2 = gp_ent.add_circle pts[i], normal, diametre, nb_edges
courbe2=cercle2[0].curve
sommets2=courbe2.vertices
loop1_edges=loop1[1].edges

	for i in 0..sommets2.length-1
	a = gp_ent.add_line(sommets1[i],sommets2[i])
	a.soft="true"
	a.smooth="true"
	end
gp_ent.transform_entities t,loop1_edges
	if (diametre<("2".to_l))
	UI.messagebox ("coucou")
	end

end
rescue
UI.messagebox ("operation debordante non autorisee")
return
end

 #____PERçAGE FRAISAGE CHAMBRAGE____________________
 begin
if choix=="percer-chambrer-fraiser"
cercle3 = gp_ent.add_circle pts[i], normal, diametre, nb_edges
courbe3=cercle3[0].curve
sommets3=courbe3.vertices

cercle1 = gp_ent.add_circle pts[i], normal, rayon, nb_edges
courbe1=cercle1[0].curve
sommets1=courbe1.vertices
loop1=sommets1[0].loops
loop1_edges=courbe1.edges

	for i in 0..sommets3.length-1
	a = gp_ent.add_line(sommets1[i],sommets3[i])
	a.soft="true"
	a.smooth="true"
	end
gp_ent.transform_entities t,loop1_edges	

end

rescue
UI.messagebox ("operation debordante non autorisee")
return
end


end
model.commit_operation

end


if not file_loaded?("percer_fraiser_chambrer_05_b_V2014_FREE_FR.rb") 
        add_separator_to_menu("Plugins")
    	  UI.menu("Plugins").add_item("percer_fraiser_chambrer_05_b_V2014_FREE_FR") {percer_fraiser_chambrer_05_b_V2014_FREE_FR}
end
